Index: sansmodels/src/sans/models/c_models/CSphereModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CSphereModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CSphereModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -185,6 +185,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -199,6 +199,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CStackedDisksModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CStackedDisksModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CStackedDisksModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -205,6 +205,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -219,6 +219,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CTriaxialEllipsoidModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CTriaxialEllipsoidModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CTriaxialEllipsoidModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -196,6 +196,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -210,6 +210,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CVesicleModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CVesicleModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CVesicleModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -190,6 +190,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -204,6 +204,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/wrapping.py
===================================================================
--- sansmodels/src/sans/models/c_models/wrapping.py	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
+++ sansmodels/src/sans/models/c_models/wrapping.py	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -0,0 +1,23 @@
+import sys
+import os
+import os.path
+from WrapperGenerator import WrapperGenerator
+
+
+root= os.path.dirname(os.getcwd())
+
+dir = os.path.join(root, "c_extensions")
+#print "dir", dir
+list= os.listdir(dir)
+nModels=0
+for item in list:
+    toks = os.path.splitext(os.path.basename(item))
+    if toks[1]=='.h':
+        nModels += 1
+        name = toks[0]
+        app = WrapperGenerator(os.path.join('..','c_extensions',name+".h"))
+        app.read()
+        app.write_c_wrapper()
+        app.write_python_wrapper()
+        print app
+print "Number total of models is %s"%nModels
Index: sansmodels/src/sans/models/test/utest_models.py
===================================================================
--- sansmodels/src/sans/models/test/utest_models.py	(revision 26e4a247fb629283560bcebfc702766d91e89b16)
+++ sansmodels/src/sans/models/test/utest_models.py	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -24,9 +24,9 @@
     def test1D(self):
         """ Test 1D model for a sphere """
-        self.assertAlmostEqual(self.comp.run(1.0), 56.3878, 4)
+        self.assertAlmostEqual(self.comp.run(1.0), 5.6387e-5, 4)
         
     def test1D_2(self):
         """ Test 2D model for a sphere """
-        self.assertAlmostEqual(self.comp.run([1.0, 1.3]), 56.3878, 4)
+        self.assertAlmostEqual(self.comp.run([1.0, 1.3]), 5.6387e-5, 4)
 
 class TestCyl(unittest.TestCase):
